"""
    PandaDoc Public API

    PandaDoc Public API documentation  # noqa: E501

    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from pandadoc_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from pandadoc_client.exceptions import ApiAttributeError


def lazy_import():
    from pandadoc_client.model.quote_update_request_discounts import QuoteUpdateRequestDiscounts
    from pandadoc_client.model.quote_update_request_options import QuoteUpdateRequestOptions
    from pandadoc_client.model.quote_update_request_price_settings import QuoteUpdateRequestPriceSettings
    globals()['QuoteUpdateRequestDiscounts'] = QuoteUpdateRequestDiscounts
    globals()['QuoteUpdateRequestOptions'] = QuoteUpdateRequestOptions
    globals()['QuoteUpdateRequestPriceSettings'] = QuoteUpdateRequestPriceSettings


class UpdateIntegrationQuoteSectionItem(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('billing_frequency',): {
            'None': None,
            'WEEKLY': "weekly",
            'MONTHLY': "monthly",
            'ANNUALLY': "annually",
            'QUARTERLY': "quarterly",
            'SEMIANNUALY': "semiannualy",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'sku': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'qty': (int,),  # noqa: E501
            'price': (float,),  # noqa: E501
            'price_settings': (QuoteUpdateRequestPriceSettings,),  # noqa: E501
            'cost': (float,),  # noqa: E501
            'billing_frequency': (str, none_type,),  # noqa: E501
            'contract_term': (int, none_type,),  # noqa: E501
            'reference_id': (str, none_type,),  # noqa: E501
            'options': (QuoteUpdateRequestOptions,),  # noqa: E501
            'custom_columns': ({str: (str,)},),  # noqa: E501
            'discounts': ({str: (QuoteUpdateRequestDiscounts,)},),  # noqa: E501
            'taxes': ({str: (QuoteUpdateRequestDiscounts,)},),  # noqa: E501
            'fees': ({str: (QuoteUpdateRequestDiscounts,)},),  # noqa: E501
            'multipliers': ({str: (float,)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'sku': 'sku',  # noqa: E501
        'name': 'name',  # noqa: E501
        'description': 'description',  # noqa: E501
        'qty': 'qty',  # noqa: E501
        'price': 'price',  # noqa: E501
        'price_settings': 'price_settings',  # noqa: E501
        'cost': 'cost',  # noqa: E501
        'billing_frequency': 'billing_frequency',  # noqa: E501
        'contract_term': 'contract_term',  # noqa: E501
        'reference_id': 'reference_id',  # noqa: E501
        'options': 'options',  # noqa: E501
        'custom_columns': 'custom_columns',  # noqa: E501
        'discounts': 'discounts',  # noqa: E501
        'taxes': 'taxes',  # noqa: E501
        'fees': 'fees',  # noqa: E501
        'multipliers': 'multipliers',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """UpdateIntegrationQuoteSectionItem - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): Item ID to update. Invalid (or missing) ID causes creating a new item.. [optional]  # noqa: E501
            sku (str): Product SKU. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of "#"  # noqa: E501
            name (str): Item name. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            description (str): Item description. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            qty (int): Item QTY. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of 1  # noqa: E501
            price (float): Item price. If you create an item without providing a value, it will have the default value. If `price_settings` is passed, this value may change after the quote is updated.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            price_settings (QuoteUpdateRequestPriceSettings): [optional]  # noqa: E501
            cost (float): Item cost. If you create an item without providing a value, it will have the default value.. [optional]  # noqa: E501
            billing_frequency (str, none_type): [optional]  # noqa: E501
            contract_term (int, none_type): Contract term. Measured in units set in the `billing_frequency` parameter.. [optional]  # noqa: E501
            reference_id (str, none_type): Use this field to pass an id that references this item in external systems.. [optional]  # noqa: E501
            options (QuoteUpdateRequestOptions): [optional]  # noqa: E501
            custom_columns ({str: (str,)}): [optional]  # noqa: E501
            discounts ({str: (QuoteUpdateRequestDiscounts,)}): Item discounts.. [optional]  # noqa: E501
            taxes ({str: (QuoteUpdateRequestDiscounts,)}): Item taxes.. [optional]  # noqa: E501
            fees ({str: (QuoteUpdateRequestDiscounts,)}): Item fees.. [optional]  # noqa: E501
            multipliers ({str: (float,)}): Item multipliers.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """UpdateIntegrationQuoteSectionItem - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (str): Item ID to update. Invalid (or missing) ID causes creating a new item.. [optional]  # noqa: E501
            sku (str): Product SKU. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of "#"  # noqa: E501
            name (str): Item name. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            description (str): Item description. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            qty (int): Item QTY. If you create an item without providing a value, it will have the default value.. [optional] if omitted the server will use the default value of 1  # noqa: E501
            price (float): Item price. If you create an item without providing a value, it will have the default value. If `price_settings` is passed, this value may change after the quote is updated.. [optional] if omitted the server will use the default value of 0  # noqa: E501
            price_settings (QuoteUpdateRequestPriceSettings): [optional]  # noqa: E501
            cost (float): Item cost. If you create an item without providing a value, it will have the default value.. [optional]  # noqa: E501
            billing_frequency (str, none_type): [optional]  # noqa: E501
            contract_term (int, none_type): Contract term. Measured in units set in the `billing_frequency` parameter.. [optional]  # noqa: E501
            reference_id (str, none_type): Use this field to pass an id that references this item in external systems.. [optional]  # noqa: E501
            options (QuoteUpdateRequestOptions): [optional]  # noqa: E501
            custom_columns ({str: (str,)}): [optional]  # noqa: E501
            discounts ({str: (QuoteUpdateRequestDiscounts,)}): Item discounts.. [optional]  # noqa: E501
            taxes ({str: (QuoteUpdateRequestDiscounts,)}): Item taxes.. [optional]  # noqa: E501
            fees ({str: (QuoteUpdateRequestDiscounts,)}): Item fees.. [optional]  # noqa: E501
            multipliers ({str: (float,)}): Item multipliers.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
